' Fig. 7.8: PassArray.vb
' Passing arrays and individual array elements to procedures.

Imports System.Windows.Forms

Module modPassArray
   Dim output As String

   Sub Main()
      Dim array1 As Integer() = New Integer() {1, 2, 3, 4, 5}
      Dim i As Integer

      output = "EFFECTS OF PASSING ENTIRE ARRAY " & _
         "BY REFERENCE:" & vbCrLf & vbCrLf & _
         "The values of the original array are:" & vbCrLf

      ' display original elements of array1
      For i = 0 To array1.GetUpperBound(0)
         output &= "  " & array1(i)
      Next

      ModifyArray(array1) ' array is passed by reference

      output &= vbCrLf & _
         "The values of the modified array are:" & vbCrLf

      ' display modified elements of array1
      For i = 0 To array1.GetUpperBound(0)
         output &= "  " & array1(i)
      Next

      output &= vbCrLf & vbCrLf & _
         "EFFECTS OF PASSING ARRAY ELEMENT " & _
         "BY VALUE:" & vbCrLf & vbCrLf & "array1(3) " & _
         "before ModifyElementByVal: " & array1(3)

      ' array element passed by value
      ModifyElementByVal(array1(3))

      output &= vbCrLf & "array1(3) after " & _
         "ModifyElementByVal: " & array1(3)

      output &= vbCrLf & vbCrLf & "EFFECTS OF PASSING " & _
          "ARRAY ELEMENT BY REFERENCE:" & vbCrLf & vbCrLf & _
          "array1(3) before ModifyElementByRef: " & array1(3)

      ' array element passed by reference
      ModifyElementByRef(array1(3))

      output &= vbCrLf & "array1(3) after " & _
         "ModifyElementByRef: " & array1(3)

      MessageBox.Show(output, "Passing Arrays", _
         MessageBoxButtons.OK, MessageBoxIcon.Information)
   End Sub ' Main

   ' procedure modifies array it receives (note ByVal)
   Sub ModifyArray(ByVal arrayParameter As Integer())
      Dim j As Integer

      For j = 0 To arrayParameter.GetUpperBound(0)
         arrayParameter(j) *= 2
      Next

   End Sub ' ModifyArray

   ' procedure modifies integer passed to it
   ' original is not be modified (note ByVal)
   Sub ModifyElementByVal(ByVal element As Integer)

      output &= vbCrLf & "Value received in " & _
         "ModifyElementByVal: " & element
      element *= 2
      output &= vbCrLf & "Value calculated in " & _
         "ModifyElementByVal: " & element
   End Sub ' ModifyElementByVal

   ' procedure modifies integer passed to it
   ' original is be modified (note ByRef)
   Sub ModifyElementByRef(ByRef element As Integer)

      output &= vbCrLf & "Value received in " & _
         "ModifyElementByRef: " & element
      element *= 2
      output &= vbCrLf & "Value calculated in " & _
         "ModifyElementByRef: " & element
   End Sub ' ModifyElementByRef

End Module ' modPassArray


' *************************************************************
' * (C) Copyright 2002 by Deitel & Associates, Inc.           *
' *     and Prentice Hall.                                    *
' * All Rights Reserved.                                      *             
' *                                                           *            
' * DISCLAIMER: The authors and publisher of this book have   * 
' * used their best efforts in preparing the book. These      *
' * efforts include the development, research, and testing of *
' * the theories and programs to determine their              * 
' * effectiveness. The authors and publisher make no warranty *
' * of any kind, expressed or implied, with regard to these   *  
' * programs or to the documentation contained in these books.*
' * The authors and publisher shall not be liable in any event*
' * for incidental or consequential damages in connection     *
' * with, or arising out of, the furnishing, performance, or  *
' * use of these programs.                                    * 
' *************************************************************