' Fig. 7.9: ArrayReferenceTest.vb
' Testing the effects of passing array references using 
' ByVal and ByRef.

Module modArrayReferenceTest

   Sub Main()
      Dim i As Integer

      ' declare array references
      Dim firstArray As Integer()
      Dim firstArrayCopy As Integer()

      ' allocate firstArray and copy its reference
      firstArray = New Integer() {1, 2, 3}
      firstArrayCopy = firstArray

      Console.WriteLine("Test passing array reference " & _
         "using ByVal.")
      Console.Write("Contents of firstArray before " & _
         "calling FirstDouble: ")

      ' print contents of firstArray
      For i = 0 To firstArray.GetUpperBound(0)
         Console.Write(firstArray(i) & " ")
      Next

      ' pass firstArray using ByVal
      FirstDouble(firstArray)

      Console.Write(vbCrLf & "Contents of firstArray after " & _
         "calling FirstDouble: ")

      ' print contents of firstArray
      For i = 0 To firstArray.GetUpperBound(0)
         Console.Write(firstArray(i) & " ")
      Next

      ' test whether reference was changed by FirstDouble
      If firstArray Is firstArrayCopy Then
         Console.WriteLine(vbCrLf & "The references are " & _
            "equal.")
      Else
         Console.WriteLine(vbCrLf & "The references are " & _
            "not equal.")
      End If

      ' declare array references
      Dim secondArray As Integer()
      Dim secondArrayCopy As Integer()

      ' allocate secondArray and copy its reference
      secondArray = New Integer() {1, 2, 3}
      secondArrayCopy = secondArray

      Console.WriteLine(vbCrLf & "Test passing array " & _
         "reference using ByRef.")
      Console.Write("Contents of secondArray before " & _
         "calling SecondDouble: ")

      ' print contents of secondArray before procedure call
      For i = 0 To secondArray.GetUpperBound(0)
         Console.Write(secondArray(i) & " ")
      Next

      ' pass secondArray using ByRef
      SecondDouble(secondArray)

      Console.Write(vbCrLf & "Contents of secondArray " & _
         "after calling SecondDouble: ")

      ' print contents of secondArray after procedure call
      For i = 0 To secondArray.GetUpperBound(0)
         Console.Write(secondArray(i) & " ")
      Next

      ' test whether the reference was changed by SecondDouble
      If secondArray Is secondArrayCopy Then
         Console.WriteLine(vbCrLf & "The references are " & _
            "equal.")
      Else
         Console.WriteLine(vbCrLf & "The references are " & _
            "not equal.")
      End If

   End Sub ' Main

   ' procedure modifies elements of array and assigns 
   ' new reference (note ByVal)
   Sub FirstDouble(ByVal array As Integer())
      Dim i As Integer

      ' double each element value
      For i = 0 To array.GetUpperBound(0)
         array(i) *= 2
      Next

      ' create new reference and assign it to array
      array = New Integer() {11, 12, 13}
   End Sub ' FirstDouble

   ' procedure modifies elements of array and assigns
   ' new reference (note ByRef)
   Sub SecondDouble(ByRef array As Integer())
      Dim i As Integer

      ' double contents of array
      For i = 0 To array.GetUpperBound(0)
         array(i) *= 2
      Next

      ' create new reference and assign it to array
      array = New Integer() {11, 12, 13}
   End Sub ' SecondDouble

End Module ' modPassArray

' *************************************************************
' * (C) Copyright 2002 by Deitel & Associates, Inc.           *
' *     and Prentice Hall.                                    *
' * All Rights Reserved.                                      *             
' *                                                           *            
' * DISCLAIMER: The authors and publisher of this book have   * 
' * used their best efforts in preparing the book. These      *
' * efforts include the development, research, and testing of *
' * the theories and programs to determine their              * 
' * effectiveness. The authors and publisher make no warranty *
' * of any kind, expressed or implied, with regard to these   *  
' * programs or to the documentation contained in these books.*
' * The authors and publisher shall not be liable in any event*
' * for incidental or consequential damages in connection     *
' * with, or arising out of, the furnishing, performance, or  *
' * use of these programs.                                    * 
' *************************************************************