' Fig 7.17: JaggedArray.vb
' Jagged two-dimensional array example.

Imports System.Windows.Forms

Module modJaggedArray
   Dim lastStudent, lastExam As Integer
   Dim output As String

   Sub Main()
      Dim i As Integer

      ' jagged array with 3 rows of exam scores
      Dim gradeArray As Integer()() = New Integer(2)() {}

      ' allocate each row with 4 student grades
      gradeArray(0) = New Integer() {77, 68, 86, 73}
      gradeArray(1) = New Integer() {98, 87, 89, 81}
      gradeArray(2) = New Integer() {70, 90, 86, 81}

      ' upper bounds for array manipulations
      lastStudent = gradeArray.GetUpperBound(0)
      lastExam = gradeArray(0).GetUpperBound(0)

      output = "Students      \      Exams" & vbCrLf

      ' build output string
      BuildString(gradeArray)
      output &= vbCrLf & vbCrLf & "Lowest grade: " & _
         Minimum(gradeArray) & vbCrLf & "Highest grade: " & _
         Maximum(gradeArray) & vbCrLf

      ' calculate each student's average
      For i = 0 To lastStudent
         output &= vbCrLf & "Average for student " & _
            i & " is " & Average(gradeArray(i))
      Next

      MessageBox.Show(output, "Jagged two-dimensional array", _
         MessageBoxButtons.OK, MessageBoxIcon.Information)
   End Sub ' Main

   ' find minimum grade
   Function Minimum(ByVal grades As Integer()()) _
      As Integer

      Dim lowGrade As Integer = 100
      Dim i, j As Integer

      For i = 0 To lastStudent

         For j = 0 To lastExam

            If grades(i)(j) < lowGrade Then
               lowGrade = grades(i)(j)
            End If

         Next

      Next

      Return lowGrade
   End Function ' Minimum

   ' find the maximum grade
   Function Maximum(ByVal grades As Integer()()) _
      As Integer

      Dim highGrade As Integer = 0
      Dim i, j As Integer

      For i = 0 To lastStudent

         For j = 0 To lastExam

            If grades(i)(j) > highGrade Then
               highGrade = grades(i)(j)
            End If

         Next

      Next

      Return highGrade
   End Function ' Maximum

   ' determine the average grade for student
   ' (or set of grades)
   Function Average(ByVal setOfGrades As Integer()) _
      As Double

      Dim i As Integer, total As Integer = 0

      ' find sum of student's grades
      For i = 0 To lastExam
         total += setOfGrades(i)
      Next

      Return total / setOfGrades.Length
   End Function ' Average

   ' creates String displaying array
   Sub BuildString(ByVal grades As Integer()())
      Dim i, j As Integer

      ' align column heads
      output &= "         "

      For i = 0 To lastExam
         output &= "(" & i & ")  "
      Next

      For i = 0 To lastStudent
         output &= vbCrLf & "   (" & i & ")  "

         For j = 0 To lastExam
            output &= grades(i)(j) & "   "
         Next

      Next

   End Sub ' BuildString

End Module ' modJaggedArray

' *************************************************************
' * (C) Copyright 2002 by Deitel & Associates, Inc.           *
' *     and Prentice Hall.                                    *
' * All Rights Reserved.                                      *             
' *                                                           *            
' * DISCLAIMER: The authors and publisher of this book have   * 
' * used their best efforts in preparing the book. These      *
' * efforts include the development, research, and testing of *
' * the theories and programs to determine their              * 
' * effectiveness. The authors and publisher make no warranty *
' * of any kind, expressed or implied, with regard to these   *  
' * programs or to the documentation contained in these books.*
' * The authors and publisher shall not be liable in any event*
' * for incidental or consequential damages in connection     *
' * with, or arising out of, the furnishing, performance, or  *
' * use of these programs.                                    * 
' *************************************************************
